#### Activity
# Data Encoding
 
### Learning Objectives
* [LO 2.1.2] Explain how binary sequences are used to represent digital data.
 
Different number bases, including binary, decimal, and hexadecimal can be used to encode different types of data, depending on the context in which it's used. One example of this is the "ASCII standard" for encoding text. 
 
### What you need:
 
- A "binary to ascii" and "ascii to binary" converting webpage.
 - http://www.binaryhexconverter.com/binary-to-ascii-text-converter
 - http://www.binaryhexconverter.com/ascii-text-to-binary-converter
- An ASCII encoded binary "secret message". 
 - Create your own with the ascii to binary converter, or use this one:
```
01000010 01100101 00100000 01110011 01110101 01110010 01100101 00100000
01110100 01101111 00100000 01100100 01110010 01101001 01101110 01101011
00100000 01111001 01101111 01110101 01110010 00100000 01001111 01110110
01100001 01101100 01110100 01101001 01101110 01100101 00100000 01100001
01101110 01100100 00100000 01110000 01101100 01100001 01111001 00100000
01000011 01101111 01100100 01100101 01000011 01101111 01101101 01100010
01100001 01110100 00100001
```
 
### Activity #1: Decode the Secret Message
 
1. Give the students the "secret message".
2. Direct the students to go to a "binary to ascii converter" in a web browser (or have them use Google to find one).
3. Each student copies the binary code into the converter to decipher its contents.
 
### Activity #2: Send a Secret Message
 
1. Pair the students up.
2. Direct each student to an "ascii to binary converter" web page.
3. Each student will type a secret message in ASCII text, then use the converter to change it into binary.
4. The students should exchange secret messages with their partner, and use a "binary to ascii converter" to decipher their partner's secret message.
	

### Discussion Questions:
- ASCII is a standard format used to represent text in binary form. Can you think of any other digital formats you use online? For images? For music?
- Why is it important to have commonly agreed upon formats for digital data?

### Challenge Questions: 
- A sequence of bits can represent many different things. The letter A, in binary is 01000001. If the same bits were used to represent a number, what number would it be?
- If you only have 8 bits, what is the highest integer you can represent in binary?
- Given the binary representation of an ASCII letter A, how would it be represented in hexadecimal?
